# print_multiple_graphs.jl

using Plots
using Dierckx
using Polynomials
using JLD2
using JLD

gr()

p1 = plot(xlabel="Energy (a.u.)",
    ylabel="Transmission Probability",
    xlim = [2,15],
    tickfontsize = 10,
    legend=:bottomright)

# -----------------------------------------------
# main_2d.out
k_range = [4, 5, 6, 7, 8, 8.5, 8.75, 8.85, 9, 9.5, 10, 11, 12, 13, 14, 15, 17.5, 20, 25, 30]
# transm = [0.0, 0.0, 0.0, 0.0, 0.0845, 0.1155, 0.133, 0.144, 0.149, 
#            0.168, 0.1995, 0.228, 0.236, 0.291, 0.3425, 
#            0.3605, 0.4375, 0.5105, 0.622, 0.7255]
k_range = [7, 8, 8.5, 8.75, 8.85, 9, 9.5, 10, 11, 12]

transm = [0.0355, 0.4065, 0.9265, 0.915, 0.9165, 0.928, 0.946, 0.947, 0.9455, 0.9435]
# transm = [0.0, 0.0965, 0.1265, 0.1475, 0.1505, 0.1285, 0.1535, 0.1795, 0.2055, 0.249,
#     0.281, 0.329, 0.3645, 0.4305, 0.487, 0.621, 0.703]
plot!(k_range, transm,
    line = (:purple),
    linewidth = 2,
    markersize = 5,
    markershape=:diamond,
    markercolor=:purple,
    markerstrokecolor = :purple,
    label="Standard FSSH")
# plot!(k_range, transm, seriestype = :scatter,label="")
# -----------------------------------------------
# -----------------------------------------------
# simple_ehrenfest.jl
# simple_ehrenfest.out
# standard_ehrenfest_erik.out
k_range = [2,3,4,5,6,7,8, 8.5, 9, 9.5, 10, 11, 12, 13, 15, 17.5, 20, 25, 30]
t = [0.0013999425781301591, 0.07537347658383087, 0.0573106472798822, 0.09529349714865712,
    0.3565087612592787, 0.37760534205097335, 0.39649317170211473, 0.41453367405344216,
    0.4320713052535279, 0.46641591370102, 0.5001672687193351, 0.5331512459661875,
    0.5951771270107584, 0.6625474770959036, 0.7178721251624632, 0.7983546667292009, 0.8507789817122509]
transm = [0.0013999425781301591, 0.07537347658383087, 0.0573106472798822,
    0.09529349714865712, 0.12763162535792738, 0.14258423467513825,
    0.1572249282841485, 0.17185391002790024, 0.18669689987372642,
    0.21754635524430616, 0.25016953112453333, 0.28425374215853066,
    0.35423797113399985, 0.4389721395465503, 0.515342845633697,
    0.637371289553109, 0.7238255806240907]
transm = [9.349221298322534e-25, 3.277328519803152e-15, 1.1520383029951705e-9, 
          2.0706032813108688e-6, 0.00024509807622277843, 0.005691972644980824, 
          0.04362507666998038, 0.086810843493735, 0.1694618312854264, 0.8751963330933739, 
          0.9043256406942378, 0.9271001613517449, 0.9388180423694867, 0.9467550104910746, 
          0.9577663624409573, 0.9670988154699595, 0.9737110222459513, 0.98227497588535, 0.9873687645362723]

plot!(k_range, transm,
    line = (:red),
    linewidth = 2,
    markershape=:x,
    markersize = 5,
    markercolor=:red,
    markerstrokecolor=:red,
    label="Ehrenfest (CG)")
# plot!(k_range, t.^2, seriestype = :scatter, label="")



# -----------------------------------------------
# top_force.out

# k_range = [4.0, 5.0, 6.0, 7.0, 8.0, 8.5, 9.0, 9.5, 10.0, 11.0, 12.0, 13.0, 15.0, 17.5, 20.0, 25.0, 30.0]
# transm = [0.0013999425781301591, 0.07537347658383087, 0.0573106472798822, 
#           0.09529349714865712, 0.12763162535792738, 0.14258423467513825,
#           0.1572249282841485, 0.17185391002790024, 0.18669689987372642,
#           0.21754635524430616, 0.25016953112453333, 0.28425374215853066, 
#           0.35423797113399985, 0.4389721395465503, 0.515342845633697, 
#           0.637371289553109, 0.7238255806240907]

# This plot is the same algorithm as Ext Ehrenfest (CG)
# plot!(k_range, transm,
#     line = (:pink),
#     linewidth = 2,
#     markershape=:o,
#     markersize = 5,
#     markercolor=:pink,
#     markerstrokecolor=:pink,
#     label="top force")
# -----------------------------------------------
# standard_ehrenfest.out
# old modified_wrong_ehrenfest.out 

transm = [0.04745653041721434, 0.11507416163914863, 0.839673561642277, 0.8927288270775446, 
          0.912016044105237, 0.9309784139790944, 0.941531914020578, 0.9488802487016713, 
          0.9593089846826075, 0.9683601606148193, 0.9748636660799817, 
          0.9833819235346895, 0.9885031978327097]

k_range = [8.0, 8.5, 9.0, 9.5, 10.0, 11.0, 12.0, 13.0, 15.0, 17.5, 20.0, 25.0, 30.0]

plot!(k_range, transm,
    line = (:blue),
    linewidth = 2,
    markershape=:utriangle,
    markersize = 5,
    markercolor=:blue,
    markerstrokecolor = :blue,
    label="Standard Ehrenfest")
#
# ------------------------------------------------------------------------------
# extended_ehrenfest_erik.out
# k_range = [4.0, 5.0, 6.0, 7.0, 8.0, 8.5, 9.0, 9.5, 10.0, 11.0, 12.0, 13.0, 15.0, 17.5, 20.0, 25.0, 30.0]
# 
# transm = [3.0690625522226084e-10, 2.4800554031108367e-6, 0.0005304055241285503, 
#           0.0033952576618415673, 0.040225828460009584, 0.059251730761522625, 
#           0.07752292165600702, 0.09535389705723328, 0.1130685267803067, 
#           0.1490150097302425, 0.1862645607785577, 0.22477335124059614, 
#           0.3033903614179563, 0.39836190021975854, 0.4836376432470471, 
#           0.618568570527625, 0.7125619747802961]
# 
# plot!(k_range, transm,
#     line = (:orange),
#     linewidth = 2,
#     markershape=:x,
#     markersize = 5,
#     markercolor=:orange,
#     markerstrokecolor = :orange,
#     label="Ext Ehrenfest")


# ------------------------------------------------------------------------------
# results from quantum dynamics
k_range= [7.8, 6.0, 8.0, 4.0, 9.4, 7.5, 9.2, 2.0, 8.5, 7.0, 12.0, 10.0, 8.8, 14.0, 3.0, 9.6, 8.2]
trasm= [0.1623364593877287, 0.008929831602500974, 0.3030784262264713, 0.016028362372734885, 
        0.920067441601576, 0.08458221839606156, 0.903714271378691, 0.1152344348607741, 
        0.667482879505275, 0.014390734042906193, 0.948797217047637, 0.9353353389109123, 
        0.7969338218048981, 0.9578116958398682, 0.0447920899686587, 0.928308938650622, 0.48938856851023577]

k_range= [7.8, 6.0, 5.5, 8.0, 4.0, 9.4, 7.5, 3.5, 9.2, 2.0, 8.5, 4.5, 7.0, 12.0, 10.0, 8.8, 6.5, 5.0, 14.0, 2.5, 3.0, 9.6, 8.2]
trasm= [0.1623364593877287, 0.005735200504306361, 0.004659366820070163, 
        0.3030784262264713, 0.0010341794775438028, 0.920067441601576, 
        0.08458221839606156, 0.0003529400884951368, 0.903714271378691, 
        4.3449260667671005e-05, 0.667482879505275, 0.0018364548340347238, 
        0.014390734042906193, 0.948797217047637, 0.9353353389109123, 
        0.7969338218048981, 0.00429739931001763, 0.0037844990545666934, 
        0.9578116958398682, 7.072720838691318e-05, 
        0.0001856470069423924, 0.928308938650622, 0.48938856851023577]
I = sortperm(k_range)

plot!(k_range[I], trasm[I],
    line = (:black),
    linewidth = 2,
    markershape=:circle,
    markersize = 5,
    markercolor=:black,
    markerstrokecolor = :black,
    label="Exact WPQD")

# ------------------------------------------------------------------------------

# ===============================================
savefig(p1, "trasmission.png")
# ------------------------------------------------------------------------------
